//
// Created by philipp on 29.11.17.
//

#ifndef PROTOCOL_ENPOINTINFO_H
#define PROTOCOL_ENPOINTINFO_H

#include <string>
#include <boost/asio/ip/tcp.hpp>
#include "Protocol.h"

using boost::asio::ip::tcp;

namespace platoonProtocol
{
class VehicleEndpoint
{
public:
    friend bool operator==(const VehicleEndpoint & lhs, const VehicleEndpoint & rhs);

    VehicleEndpoint()
        : vehicleId(0)
          , host("")
          , tcpPort(0)
          , udpPort(0)
    {}

    VehicleEndpoint(VehicleId vehicleId, const std::string & host, std::uint16_t tcpPort, std::uint16_t udpPort)
        : vehicleId(vehicleId)
          , host(host)
          , tcpPort(tcpPort)
          , udpPort(udpPort)
    {}

    VehicleId getVehicleId() const noexcept
    { return vehicleId; }

    std::string getHost() const noexcept
    { return host; }

    std::uint16_t getTcpPort() const noexcept
    { return tcpPort; }

    std::uint16_t getUdpPort() const noexcept
    { return udpPort; }

    explicit operator bool() const noexcept
    { return vehicleId != 0; }

private:
    VehicleId vehicleId;
    std::string host;
    std::uint16_t tcpPort;
    std::uint16_t udpPort;
};

bool operator==(const VehicleEndpoint & lhs, const VehicleEndpoint & rhs);

}

#endif //PROTOCOL_ENPOINTINFO_H
